/*
 *	Ohio Trollius
 *
 * Copyright (c) 2001-2002 The Trustees of Indiana University.  
 *                         All rights reserved.
 * Copyright (c) 1998-2001 University of Notre Dame. 
 *                         All rights reserved.
 * Copyright (c) 1994-1998 The Ohio State University.  
 *                         All rights reserved.
 * 
 * This file is part of the XMTV software package.  For license
 * information, see the LICENSE file in the top level directory of the
 * XMTV source distribution.
 *
 *	$Id: rtvstate.c,v 1.3 2002/12/09 20:25:14 brbarret Exp $
 * 
 *	Function:	- get status of graphic frame
 *	Accepts: 	- destination node
 *			- ptr to state structure
 *	Returns:	- 0 or ERROR
 */

#include <events.h>
#include <ksignal.h>
#include <net.h>
#include <portable.h>
#include <terror.h>
#include <typical.h>
#include <tvreq.h>


int
lam_rtvstate(node, ptvstate)

int4			node;
struct tvstate		*ptvstate;

{
	struct nmsg	nhead;		/* message header */
	struct tvreq	*request;	/* ptr to mtvd request */
	struct tvreply	*reply;		/* ptr to mtvd reply */
	int4		mask;

 	request = (struct tvreq *) nhead.nh_data;
	reply = (struct tvreply *) nhead.nh_data;
/*
 * Set up the request message.
 */
	request->tvq_req = TVQSTATE;
	request->tvq_src_event = -getpid();
	request->tvq_src_node = (node == LOCAL) ? node : getnodeid();

	nhead.nh_node = node;
	nhead.nh_event = EVMTVD;
	nhead.nh_type = 0;
	nhead.nh_flags = 0;
	nhead.nh_length = 0;
	nhead.nh_msg = 0;

	if (nsend(&nhead)) {
		return(ERROR);
	}

	mask = ksigblock(sigmask(SIGUDIE) | sigmask(SIGARREST));
/*
 * Get the reply.
 */
	nhead.nh_event	= -getpid();

	if (nrecv(&nhead)) {
		ksigsetmask(mask);
		return(ERROR);
	}

	ksigsetmask(mask);

	if (reply->tvr_ret) {
		errno = reply->tvr_errno;
		return(ERROR);
	}
	else {
		ptvstate->tvs_xlen = reply->tvr_xlen;
		ptvstate->tvs_ylen = reply->tvr_ylen;
		ptvstate->tvs_ncolour = reply->tvr_ncolour;
		ptvstate->tvs_xtext = reply->tvr_xtext;
		ptvstate->tvs_ytext = reply->tvr_ytext;
		return(0);
	}
}
